import type { IntlType } from '@ant-design/pro-provider';
import React from 'react';
import './index.less';
export declare type AlertRenderType<T> = ((props: {
    intl: IntlType;
    selectedRowKeys: (number | string)[];
    selectedRows: T[];
    onCleanSelected: () => void;
}) => React.ReactNode) | false;
export declare type TableAlertProps<T> = {
    selectedRowKeys: (number | string)[];
    selectedRows: T[];
    alwaysShowAlert?: boolean;
    alertInfoRender?: AlertRenderType<T>;
    onCleanSelected: () => void;
    alertOptionRender?: AlertRenderType<T>;
};
declare function TableAlert<T>({ selectedRowKeys, onCleanSelected, alwaysShowAlert, selectedRows, alertInfoRender, alertOptionRender, }: TableAlertProps<T>): JSX.Element | null;
export default TableAlert;
