"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/lib/dropdown"));

require("antd/lib/menu/style");

var _menu = _interopRequireDefault(require("antd/lib/menu"));

require("antd/lib/config-provider/style");

var _configProvider = _interopRequireDefault(require("antd/lib/config-provider"));

var _jsxRuntime = require("react/jsx-runtime");

var _icons = require("@ant-design/icons");

var _classnames = _interopRequireDefault(require("classnames"));

var _react = require("react");

require("./index.less");

var _excluded = ["key", "name"];

/**
 * 一个简单的下拉菜单
 *
 * @param param0
 */
var DropdownButton = function DropdownButton(_ref) {
  var children = _ref.children,
      menus = _ref.menus,
      onSelect = _ref.onSelect,
      className = _ref.className,
      style = _ref.style;

  var _useContext = (0, _react.useContext)(_configProvider.default.ConfigContext),
      getPrefixCls = _useContext.getPrefixCls;

  var tempClassName = getPrefixCls('pro-table-dropdown');
  var menu = (0, _jsxRuntime.jsx)(_menu.default, {
    onClick: function onClick(params) {
      return onSelect && onSelect(params.key);
    },
    items: menus === null || menus === void 0 ? void 0 : menus.map(function (item) {
      return {
        label: item.name,
        key: item.key
      };
    })
  });
  return (0, _jsxRuntime.jsx)(_dropdown.default, {
    overlay: menu,
    className: (0, _classnames.default)(tempClassName, className),
    children: (0, _jsxRuntime.jsxs)(_button.default, {
      style: style,
      children: [children, " ", (0, _jsxRuntime.jsx)(_icons.DownOutlined, {})]
    })
  });
};

var TableDropdown = function TableDropdown(_ref2) {
  var propsClassName = _ref2.className,
      style = _ref2.style,
      onSelect = _ref2.onSelect,
      _ref2$menus = _ref2.menus,
      menus = _ref2$menus === void 0 ? [] : _ref2$menus,
      children = _ref2.children;

  var _useContext2 = (0, _react.useContext)(_configProvider.default.ConfigContext),
      getPrefixCls = _useContext2.getPrefixCls;

  var className = getPrefixCls('pro-table-dropdown');
  var menu = (0, _jsxRuntime.jsx)(_menu.default, {
    onClick: function onClick(params) {
      onSelect === null || onSelect === void 0 ? void 0 : onSelect(params.key);
    },
    items: menus.map(function (_ref3) {
      var key = _ref3.key,
          name = _ref3.name,
          rest = (0, _objectWithoutProperties2.default)(_ref3, _excluded);
      return (0, _objectSpread2.default)((0, _objectSpread2.default)({
        key: key
      }, rest), {}, {
        title: rest.title,
        label: name
      });
    })
  });
  return (0, _jsxRuntime.jsx)(_dropdown.default, {
    overlay: menu,
    className: (0, _classnames.default)(className, propsClassName),
    children: (0, _jsxRuntime.jsx)("a", {
      style: style,
      children: children || (0, _jsxRuntime.jsx)(_icons.EllipsisOutlined, {})
    })
  });
};

TableDropdown.Button = DropdownButton;
var _default = TableDropdown;
exports.default = _default;