import type { ProFieldEmptyText } from '@ant-design/pro-field';
import type { ProFormFieldProps } from '@ant-design/pro-form';
import type { ProSchemaComponentTypes, UseEditableUtilType } from '@ant-design/pro-utils';
import React from 'react';
import type { useContainer } from '../container';
import type { ProColumnType } from '../index';
/**
 * 拼接用于编辑的 key
 */
export declare const spellNamePath: (...rest: any[]) => React.Key[];
declare type CellRenderFromItemProps<T> = {
    text: string | number | React.ReactText[];
    valueType: ProColumnType['valueType'];
    index: number;
    rowData?: T;
    columnEmptyText?: ProFieldEmptyText;
    columnProps?: ProColumnType<T> & {
        entity: T;
    };
    type?: ProSchemaComponentTypes;
    recordKey?: React.Key;
    mode: 'edit' | 'read';
    /**
     * If there is, use EditableTable in the Form
     */
    prefixName?: string;
    counter: ReturnType<typeof useContainer>;
    proFieldProps: ProFormFieldProps;
    subName: string[];
    editableUtils: UseEditableUtilType;
};
/**
 * 根据不同的类型来转化数值
 *
 * @param text
 * @param valueType
 */
declare function cellRenderToFromItem<T>(config: CellRenderFromItemProps<T>): React.ReactNode;
export default cellRenderToFromItem;
