import type { ProFieldEmptyText } from '@ant-design/pro-field';
import type { ProSchemaComponentTypes, UseEditableUtilType } from '@ant-design/pro-utils';
import React from 'react';
import type { useContainer } from '../container';
import type { ProColumns } from '../typing';
/** 转化列的定义 */
declare type ColumnRenderInterface<T> = {
    columnProps: ProColumns<T>;
    text: any;
    rowData: T;
    index: number;
    columnEmptyText?: ProFieldEmptyText;
    type: ProSchemaComponentTypes;
    counter: ReturnType<typeof useContainer>;
    editableUtils: UseEditableUtilType;
    subName: string[];
};
/**
 * 增加了 icon 的功能 render title
 *
 * @param item
 */
export declare const renderColumnsTitle: (item: ProColumns<any>) => string | number | boolean | React.ReactFragment | JSX.Element | null | undefined;
/**
 * 默认的 filter 方法
 *
 * @param value
 * @param record
 * @param dataIndex
 * @returns
 */
export declare const defaultOnFilter: (value: string, record: any, dataIndex: string | string[]) => boolean;
/**
 * 这个组件负责单元格的具体渲染
 *
 * @param param0
 */
export declare function columnRender<T>({ columnProps, text, rowData, index, columnEmptyText, counter, type, subName, editableUtils, }: ColumnRenderInterface<T>): any;
export {};
